# 从0开始学架构

## 架构到底是指什么？

对于技术人员来说，“架构”是一个再常见不过的词了。但如果深究一下“架构”到底指什么，大部分人也许并不一定能够准确地回答。例如：

- 架构和框架是什么关系？有什么区别？
- Linux 有架构，MySQL 有架构，JVM 也有架构，使用 Java 开发、MySQL 存储、跑在 Linux 上的业务系统也有架构，应该关注哪个架构呢？
- 微信有架构，微信的登录系统也有架构，微信的支付系统也有架构，当我们谈微信架构时，到底是在谈什么架构？

**系统与子系统**

子系统的定义和系统定义是一样的，只是观察的角度有差异，一个系统可能是另外一个更大系统的子系统。按照这个定义，系统和子系统比较容易理解。我们以微信为例来做一个分析。

1. 微信本身是一个系统，包含聊天、登录、支付、朋友圈等子系统。
2. 朋友圈这个系统又包括动态、评论、点赞等子系统。
3. 评论这个系统可能又包括防刷子系统、审核子系统、发布子系统、存储子系统。
4. 评论审核子系统不再包含业务意义上的子系统，而是包括各个模块或者组件，这些模块或者组件本身也是另外一个维度上的系统。例如，MySQL、Redis 等是存储系统，但不是业务子系统。

**模块与组件**

模块和组件都是系统的组成部分，只是从不同的角度拆分系统而已。

从**逻辑的角度**来拆分系统后，得到的单元就是“模块”；从**物理的角度**来拆分系统后，得到的单元就是“组件”。划分模块的主要目的是职责分离；划分组件的主要目的是单元复用。

> 架构是顶层设计；框架是面向编程或配置的半成品；组件是从技术维度上的复用；模块是从业务维度上职责的划分；系统是相互协同可运行的实体。
