# 基础知识
	###ES6常用语法（Class Module Promise等）
	###原型高级应用（结合jquery和zepto源码）
	###异步全面讲解（从原理到jquery再到promise）
# 框架原理
	###虚拟DOM（存在价值，使用，diff算法）
	###MVVM vue（MVVN，vue响应式，模板解析，渲染）
	###组件化react（组件化，jsx，vdom，setState）
	###对比
# 混合开发
	###hybrid（基础，和h5对比，上线流程）
	###hybrid vs H5
	###前端客户端通讯（通讯原理，JS-Bridge封装）
# 课外
	读书
	博客
	开源

###题目
	·es6
		·模块化的使用和编译环境
			q：es6模块化如何使用，开发环境如何打包
			a：
				·模块化的基本语法
					/* util1.js */
					export default {
						a: 100
					}
					/* util2.js */
					export function fn1(){
						alert('fn1')
					}
					export function fn2(){
						alert('fn2')
					}
					/* index.js */
					import util1 from './util1.js'
					import { fn1,fn2 } from './util2.js'
				·开发环境配置
					babel
					webpack
					rollup
						.babelrc
							{
								"presets": [
									["latest", {
										"es2015": {
											"modules": false
										}
									}]
								],
								"plugins": ["external-helpers"]
							}
						rollup.config.js
							import babel from 'rollup-plugin-babel'
							import resolve from 'rollup-plugin-node-resolve'

							export default {
								entry: 'src/index.js',
								format: 'umd',
								plugins: [
									resolve(),
									babel({
										exclude: 'node_modules/**'
									})
								],
								dest: 'build/bundle.js'
							}
							"scripts":{
								"start": "rollup -c rollup.config.js"
							}
				·关于js众多模块化标准
					·没有模块化
					·AMD成为标准，require.js（也有CMD）
					·前端打包工具
					·es6出现，想统一现在所有模块化标准
					·nodejs积极支持，浏览器尚未统一
					·你可以自造lib，但不要自造标准
					q：
						·语法： import export（注意有无default）
						·环境：babel编译ES6语法，模块化可用webpack和rollup
						·扩展：说一下对模块化标准统一的期待
		·Class与JS构造函数的区别
			·js构造函数
				function MathHandle(x, y){
					this.x = x;
					this.y = y;
				}
				MathHandle.prototype.add = function(){
					return this.x + this.y
				}
				var  m = new MathHandle(1,2)
				typeof MathHandle // 'function'
				MathHandle.prototype.constructor === MathHandle // true
				m.__proto__ === MathHandle.prototype // true
			·class基本语法
				class MathHandle {
					constructor(x, y){
						this.x = x;
						this.y = y;
					}
					add() {
						return this.x + this.y
					}
				}
				const m = new MathHandle(1,2);
			·语法糖
				本质一样，写法不一样。
				class本身就是function
			·继承 - JS
				//动物
				function Animal(){
					this.eat = function(){
						console.log('animal eat')
					}
				}
				//狗
				function Dog(){
					this.bark = function(){
						console.log('dog bark')
					}
				}
				Dog.prototype = new Animal()
				var hashiqi = new Dog()

				class Animal {
					constructor(name){
						this.name = name
					}
					eat() {
						console.log(`${this.name} eat`)
					}
				}
				class Dog extends Animal{
					constructor(name){
						super(name)
						this.name = name
					}
					say() {
						console.log(`${this.name} say`)
					}
				}
				const dog = new Dog('哈士奇')

				·question&answer
					· Class 在语法上更加贴合面向对象的写法
					· Class 实现继承更加易读、易理解
					· 更易于写 java 等后端语言的使用
					· 本质还是语法糖，使用 prototype
		·Promise的用法
			q：promise基本使用和原理
				function loadImg(src, callback, fail){
					var img = document.createElement('img')
					img.onload = function(){
						callback(img)
					} 
					img.onerror = function(){
						fail()
					}
					img.src = src
				}
				var src = 'http://www.baidu.com/images/index/logo.png'

				function loadImg(src){
					const promise = new Promise(function(resolve,reject){
					var img = document.createElement('img')
					img.onload = function(){
						resolve(img)
					}
					img.onerror = function(){
						reject()
					}
					img.src = src
					})
					return promise
				}
				var src = 'http://www.baidu.com/images/index/logo.png'
				var result = loadImg(src)
				result.then(function(img){
					console.log(img.width)
				}, function(){
					console.log('failed')
				})
				result.then(function(img){
					console.log(img.height)
				})

				·question&answer
					·new Promise实例，而且要return
		·ES6其他常用功能
			q:总结一下es6其他常用功能
				let/const
				多行字符串/模板变量
					`<div>
						<p>${name}</p>
					</div>
					`
				解构赋值
				块级作用域
				函数默认参数
				function (a, b=0){}
				箭头函数
	·异步
		·单线程？和异步有何关系
			同一时间只能做一件事
			原因：避免dom渲染的冲突
				浏览器需要渲染dom
				js可以修改dom结构
				js执行的时候，浏览器dom渲染会暂停
				两端js也不能同时执行（都修改dom就冲突了）
				webworker支持多线程，但是不能访问dom
			解决方案：异步
				setTimeout
					没按照书写方式执行，可读性差
					callback回调中不容易模块化
		·event-loop
			·事件轮询，js实现异步的具体解决方案
			·同步代码，直接执行
			·异步函数先放在异步队列中
			·待同步函数执行完毕，轮询执行异步队列的函数
		·js解决异步的方案
			事件轮询
		·只用jquery如何解决异步
			·jq1.5变化 
			·使用jquery Deferred 
				·总结，dtd的API可分为两类，用意不同
				·第一类：dtd.resolve dtd.reject
				·第二类：dtd.then dtd.done dtd.fail
				·这两类应该分开，否则后果严重！
				var wait = fucntion(){
					var task = function(){}
					setTimeout(task, 2000)
				}
				wait()

				function waitHandle(){
					var dtd = $.Deferred()
					var wait = function(dtd){
						var task = function(){
							dtd.resolve() //表示异步任务已经完成
							// dtd.reject() //表示异步任务失败或出错
						}
						setTimeout(task, 2000)
						return dtd // 要求返回deferred对象
					}
					// 这里一定要有返回值
					return wait(dtd)
				}
				//使用
				var w = waitHandle()
				w.then(function(){}, function(){})
				.then(function(){}, function(){})
			初步引入Promise概念
				var ajax = $.ajax('data.json')
				ajax.done(function(){})
				.fail(function(){})
				.done(function(){})
				//像promise写法
				var ajax = $.ajax('data.json')
				ajax.then(function(){},function(){})
				.then(function(){},function(){})
			·无法改变异步和单线程的本质
			·只能从写法上杜绝callback形式
			·它是一种语法糖形式，但是解耦了代码
			·很好的体现：开放封闭原则（对扩展开放，对修改封闭）

			·使用dtd.promise
				function waitHandle(){
					var dtd = $.Deferred()
					var wait = function(dtd){
						var task = function(){
							dtd.resolve() //表示异步任务已经完成
							// dtd.reject() //表示异步任务失败或出错
						}
						setTimeout(task, 2000)
						return dtd.promise() // 这里返回的是promise对象
					}
					// 这里一定要有返回值
					return wait(dtd)
				}
				//这里接收的是promise对象
				var w = waitHandle()
				w.then(function(){}, function(){})
				.then(function(){}, function(){})
		·promise和deferred区别
			deferred既可以执行resolve和reject这种主动干预成功或失败的函数，又可以执行.done .fail .then这种监听结果的函数。因为会产生冲突，所以有了promise实例，只能被动监听.done .fail结果，不能干预结果。
		·promise标准
			·基本语法
			·异常捕获
				// 规定：then只接受一个参数，最后统一用catch捕获异常
				result.then(function(img){})
				.then(function(img){})
				.catch(function(ex){})
			·多个串联 - 链式执行的好处
				var src1 = 'https://www.imooc.com/static/img/index/logo_new.png'
		        var result1 = loadImg(src1)
		        var src2 = 'https://img1.mukewang.com/545862fe00017c2602200220-100-100.jpg'
		        var result2 = loadImg(src2)
		        result1.then(function (img1) {
		            console.log('第一个图片加载完成', img1.width)
		            return result2  // 重要！！！
		        }).then(function (img2) {
		            console.log('第二个图片加载完成', img2.width)
		        }).catch(function (ex) {
		            console.log(ex)
		        })
		        按顺序执行
			·promise.all和promise.race
				// promise.all接收一个promise对象数组
				// 待全部完成之后，统一执行success
				Promise.all([result1,result2]).then(datas => {
					// 接收到的datas是一个数组，依次包含了多个promise返回的内容
				})

				// promise.race接收一个包含多个promise对象数组
				// 只要完成一个，就执行success
				Promise.race([result1,result2]).then(data => {
					// data即最先执行完成的promise的返回值
				})
			·primise标准
				·三种状态：pending fulfilled rejected
					初始状态是pending
					pending变为fulfilled，或者pending变为rejected
					状态变化不可逆
				·promise实例必须实现then这个方法
					then()必须可以接受两个函数作为参数
					then()返回的必须是一个promise实例
		·async/await使用
			·介绍
				·then只是将callback拆分了
				·async/await是最直接的同步写法
			·最直接的同步写法
				const load = async function(){
					const result1 = await loadImg(src1)
					console.log(result1)
					const result2 = await loadImg(src2)
					console.log(result2)
				}
				load()
			·用法
				·函数必须用async标识
				·await后面跟着的是一个promise实例
				·需要babel-polyfill
			·问题解答
				·使用了promise，并没有和promise冲突
				·完全是同步的写法，也没有回调函数
				·但是：改变不了js单线程、异步的本质
		·当前异步的解决方案
			·jquery deferred
			·promise
			·async/await
			·generator
				原理比较复杂
				不是异步的直接替代方式
				有更好更简洁的解决方案async/await
			·koa
	·原型
		·原型如何实际应用
			·jquery和zepto简单实用
			·zepto如何使用原型
				// 空对象
				var zepto = {}
				zepto.init = function(selector){
					// 源码中，处理情况比较复杂
					var slice = Array.prototype.slice
					var dom = slice.call(document.querySelectorAll(selector))
					return zepto.Z(dom, selector)
				}
				// 即使用zepto时候的$
				var $ = function(selector){
					return zepto.init(selector)
				}

				// 这就是构造函数
				function Z(dom, selector){
					var i, len=dom?dom.length:0
					for(i=0;i<len;i++) this[i]=dom[i]
					this.length = len
					this.selector=selector||''
				}
				zepto.Z = function(dom, selector){
					return new Z(dom, selector)
				}

				$.fn = {
					constructor: zepto.Z,
					css: function(key, value){

					},
					html: function(value){

					}
				}
				zepto.Z.prototype = Z.prototype = $.fn
			·jquery如何使用原型
				var jQuery = function(selector){
					// 第一步就找到构造函数
					return new jQuery.fn.init(selector)
				}
				//定义构造函数
				var init = jQuery.fn.init = function(selector){
					var slice = Array.prototype.slice
					var dom = slice.call(document.querySelectorAll(selector))

					var i, len=dom?dom.length:0
					for(i=0;i<len;i++) this[i]=dom[i]
					this.length = len
					this.selector=selector||''
				}
				//初始化jQuery.fn
				jQuery.fn = jQuery.prototype = {
					constructor: jQuery,
					css: function(key, value){

					},
					html: function(value){

					}
				}
				//定义原型
				init.prototype = jQuery.fn
		·原型如何满足扩展
			·总结zepto和jquery原型的使用
			·插件机制
			·为何要把原型方法放在$.fn
				//因为药扩展插件，做一个简单的插件的例子
				$.fn.getNodeName = function(){
					return this[0].nodeName
				}
				好处：
					·只有$会暴露在window全局变量
					·将插件扩展统一到$.fn.xxx这一接口，方便使用
	·vdom
		·介绍
			·是vue和react的核心
			·比较独立，使用也比较简单
			·vue和react实现
		·什么是vdom，为何用
			·什么是vdom
				·虚拟dom
				·用js模拟dom结构
				·dom变化的对比，放在js层来做（图灵完备语言 - 前端语言中，只有js是图灵完备语言，能实现逻辑，判断，循环，递归，算法，高复杂逻辑的语言）
				·提高重绘性能
				<ul id="list">
					<li class="item">Item 1</li>
					<li class="item">Item 2</li>
				</ul>
				{
					tag: 'ul',
					attrs: {
						id: 'list'
					},
					children: [
						{
							tag: 'li',
							attrs: {className: 'item'},
							children: ['Item 1']
						}, {
							tag: 'li',
							attrs: {className: 'item'},
							children: ['Item 2']
						}
					]
				}
			·设计一个需求场景
				//1.将该数据展示成一个表格。2.随便修改一个信息，表格也跟着修改
				[
					{
						name: '张三',
						age: '20',
						address: '北京'
					},{
						name: '李四',
						age: '21',
						address: '上海'
					},{
						name: '王五',
						age: '22',
						address: '广州'
					}
				]
			·jquery实现
				var data = [
		            {
		                name: '张三',
		                age: '20',
		                address: '北京'
		            },
		            {
		                name: '李四',
		                age: '21',
		                address: '上海'
		            },
		            {
		                name: '王五',
		                age: '22',
		                address: '广州'
		            }
		        ]
				// 渲染函数
		        function render(data) {
		            var $container = $('#container')

		            // 清空容器，重要！！！
		            $container.html('')

		            // 拼接 table
		            var $table = $('<table>')

		            $table.append($('<tr><td>name</td><td>age</td><td>address</td>/tr>'))
		            data.forEach(function (item) {
		                $table.append($('<tr><td>' + item.name + '</td><td>' + item.age + '</td><td>' + item.address + '</td>/tr>'))
		            })

		            // 渲染到页面
		            $container.append($table)
		        }
		        $('#btn-change').click(function () {
		            data[1].age = 30
		            data[2].address = '深圳'
		            // re-render  再次渲染
		            render(data)
		        })

		        // 页面加载完立刻执行（初次渲染）
		        render(data)
			·遇到的问题
				·DOM操作是”昂贵“的，js运行效率高
				·尽量减少DOM操作，而不是”推倒重来“
				·项目越复杂，影响就越严重
				·vdom就可解决这个问题
		·如何使用，核心函数
		·diff算法
		·问题解答
			·vdom是什么？为何会存在
				virtual dom，虚拟dom
				用js模拟dom结构
				dom操作非常”昂贵“
				将DOM对比操作放在js层，提高效率
			·如何应用，核心API是什么 
				介绍snabbdom（开源库）
				重做之前的demo
				核心API
					h函数（通过一些数据生成node节点）、patch函数（将vnode节点真正渲染到页面上，第二个用法将新的vnode和现有对比，重新渲染）
			·diff算法
				·什么是diff算法
				·去繁就简
					diff算法非常复杂，实现难度很大，源码量很大
					讲明白核心流程，不关心细节
				·vdom为何用diff算法
					dom操作是”昂贵“的，因此尽量减少dom操作
					找出本次dom必须更新的节点来更新，其他的不更新
					这个”找出“的过程，就需要diff算法
				·diff算法的实现流程
					·不仅仅
						·节点新增和删除
						·节点重新排序
						·节点属性、样式、事件绑定
						·如何极致压榨性能
					·patch(container,vnode)
						function createElement(vnode) {
						    var tag = vnode.tag;
						    var attrs = vnode.attrs || {};
						    var children = vnode.children

						    if (!tag) return null;

						    // 创建真实dom元素
						    var elem = document.createElement(tag);
						    var attrName;
						    for (attrName in attrs) {
						        if (attrs.hasOwnProperty(attrName)) {
						            // 添加属性
						            tag.setAttribute(attrName, attrs[attrName])
						        }
						    }

						    children.forEach(childVnode => {
						        elem.appendChild(createElement(childVnode))
						    });

						    return elem;
						}
					·patch(vnode,newVnode)
						function updateChildren(vnode, newVnode) {
						    var children = vnode.children || []
						    var newChildren = newVnode.children || []

						    children.forEach(function (childVnode, index) {
						        var newChildVnode = newChildren[index]
						        if (childVnode.tag === newChildVnode.tag) {
						            // 深层次对比，递归
						            updateChildren(childVnode, newChildVnode)
						        } else {
						            // 替换
						            replaceNode(childVnode, newChildVnode)
						        }
						    })
						}

						function replaceNode(vnode, newVnode) {
						    var elem = vnode.elem  // 真实的 DOM 节点
						    var newElem = createElement(newVnode)

						    // 替换
						}
				·问题解答
					·知道什么是diff算法，是linux的基础命令
					·vdom汇总应用diff算法是为了找出需要更新的节点
					·diff实现patch(container,vnode)，patch(vnode,newVnode)
					·核心逻辑，createElement和updateChildren
	·mvvn
		·之前使用jq和现在使用vue和react区别
			·jquery实现todo-list
			·vue实现todo-list
			·jquery和框架的区别
				·数据和视图的分离，解耦（开放封闭原则）
				·以数据驱动视图，只关心数据变化，DOM操作被封装
		·如何理解mvvm
			·MVC
				view -> controller -> model -> view
				user -> controller
			·MVVM
				view通过事件绑定影响model，model通过数据绑定影响view
				model
				view
				viewModel - 连接model和view
			·vue三要素
				·响应式 - 如何监听到data的每个属性变化
				·模板引擎 - 模板如何被解析，指令如何处理
				·渲染 - 模板如何被渲染成html？以及渲染过程
		·vue如何实现响应式
			·什么是响应式
				修改data属性之后，vue立刻监听到
				data属性被代理到vm上
			·Object.defineProperty
				var obj = {}
				var _name = 'zhangsan'
				Object.defineProperty(obj, "name", {
					get: function(){
						return _name
					},
					set: function(newVal){
						_name = newVal
					}
				})
				obj.name = lisi
			·模拟
				var mv = {}
				var data = {
					price: 100,
					name: 'zhangsan'
				}
				var key, value
				for(key in data){
					// 闭包，新建一个函数，保证key的独立作用域
					(function(key){
						Object.defineProperty(mv, key, {
							get: function(){
								return data[key]
							},
							set: function(newVal){
								data[key] = newVal
							}
						})
					})(key)
				}
				把属性的获取赋值定位到函数里去，可以在函数中添加监听代码
		·vue如何解析模板
			·模板是什么
				本质：字符串
				有逻辑，如v-if v-for等
				与html格式很像，但又很大区别，html静态的，vue中是动态的
				最终还要转换成html来显示
				模板最终必须转换成js代码，因为：
					有逻辑，必须用js才能实现（图灵完备）
					转换为html渲染页面，必须用js才能实现
					因此，模板最重要转换成一个js函数（render函数）
			·render函数
				·with的用法
					var obj = {
						name: 'zhangsan',
						age: 20,
						getAddress:function(){}
					}
					//不使用with
					function fn(){
						alert(obj.name)
					}
					fn()
					//使用with
					function fn1(){
						with(obj){
							alert(name)
						}
					}
					fn1()
				·render函数
					·示例
						<div id="app">
							<p>{{price}</p>
						</div>

						function render(){
							with(this){ //this就是vm
								return _c(
									'div',
									{
										attrs:{"id":"app"}
									},
									[
										_c('p',[_v(_s(price))])
									]
								)
							}
						}
						·模板中所有信息都包含在了render函数中
						·this即vm
						·price即this.price即vm.price，即data中的price
						·_c即this._c即vm.c
					·从哪里可以看到render函数
						code.render
					·复杂一点的例子，render函数是什么样子
					·v-if v-for v-on都是怎么处理的
					·v-model（双向数据绑定）
						_c(
                            'input',
                            {
                                directives:[
                                    {
                                        name:"model",
                                        rawName:"v-model",
                                        value:(title),
                                        expression:"title"
                                    }
                                ],
                                domProps:{
                                    "value":(title)
                                },
                                on:{
                                    "input":function($event){
                                        if($event.target.composing)return;
                                        title=$event.target.value
                                    }
                                }
                            }
                        )
                    ·v-on：click
                    	_c(
                            'button',
                            {
                                on:{
                                    "click":add
                                }
                            },
                            [_v("submit")]
                        )
                    ·v-for
                    	_c(
                            'ul',
                            _l((list),function(item){return _c('li',[_v(_s(item))])})
                        )
                	·已经解决模板中逻辑的问题
                		·还剩下模板生成html问题
                		·另外，vm._c是什么？render函数返回了什么？
                			vm._c相当于vdom（snabbdom）中的h函数
                			render函数执行之后，返回的是vnode
			·render函数与vdom
				·updateComponent中实现了vdom的patch
				·页面首次渲染执行updateComponent
				·date中每次修改属性，执行updateComponent
				vm._update(vnode){
					const prevVnode = vm._vnode
					vm._vnode = vnode
					if(!prevVnode){
						vm.$el = vm._patch_(vm.$el, vnode)
					}else{
						vm.$el = vm._patch_(prevVnode, vnode)
					}
				}
				function updateComponent(){
					// vm._render 即 上面的render函数，返回vnode
					vm._update(vm._render())
				}
		·vue整个实现流程
			·第一步：解析模板成render函数
				·with的用法
				·模板中的所有信息都被render函数包含
				·模板中用到的data中的属性，都变成了js变量
				·模板中的v-model v-for v-on都变成了js逻辑
				·render函数返回vnode
				<div id="app">
			        <div>
			            <input v-model="title">
			            <button v-on:click="add">submit</button>
			        </div>
			        <div>
			            <ul>
			                <li v-for="item in list">{{item}}</li>
			            </ul>
			        </div>
			    </div>

			    with(this){  // this 就是 vm
		            return _c(
		                'div',
		                {
		                    attrs:{"id":"app"}
		                },
		                [
		                    _c(
		                        'div',
		                        [
		                            _c(
		                                'input',
		                                {
		                                    directives:[
		                                        {
		                                            name:"model",
		                                            rawName:"v-model",
		                                            value:(title),
		                                            expression:"title"
		                                        }
		                                    ],
		                                    domProps:{
		                                        "value":(title)
		                                    },
		                                    on:{
		                                        "input":function($event){
		                                            if($event.target.composing)return;
		                                            title=$event.target.value
		                                        }
		                                    }
		                                }
		                            ),
		                            _v(" "),
		                            _c(
		                                'button',
		                                {
		                                    on:{
		                                        "click":add
		                                    }
		                                },
		                                [_v("submit")]
		                            )
		                        ]
		                    ),
		                    _v(" "),
		                    _c('div',
		                        [
		                            _c(
		                                'ul',
		                                _l((list),function(item){return _c('li',[_v(_s(item))])})
		                            )
		                        ]
		                    )
		                ]
		            )
		        }
			·第二步：响应式开始监听
				·Object.defineProperty
				·将data的属性代理到vm上
			·第三步：首次渲染，显示页面，且绑定依赖
				·初次渲染，执行updateComponent，执行vm._render()
				·执行render函数，会访问到vm.list和vm.title
				·会被响应式的get方法监听到
					·为什么不监听set
						data中有很多属性，被用到的会走get，不被用的不会走到get
						未走到get中的属性，set的时候我们也无需关心
						避免不必要的重复渲染
				·执行updateComponent，会走到vdom的patch方法
				vm._update(vnode){
					const prevVnode = vm._vnode
					vm._vnode = vnode
					if(!prevVnode){
						vm.$el = vm._patch_(vm.$el, vnode)
					}else{
						vm.$el = vm._patch_(prevVnode, vnode)
					}
				}
				function updateComponent(){
					// vm._render 即 上面的render函数，返回vnode
					vm._update(vm._render())
				}
			·第四步：data属性变化，触发rerender
				·修改属性。被响应式的set监听到
				·set中执行updateComponent
				·updateComponent重新执行vm.render()
				·生成的vnode和prevnode，通过patch进行对比
				·渲染到html中
	·组件化
		·组件化理解
			·组件的封装
				·视图
				·数据
				·变化逻辑（数据驱动视图变化）
			·组件的复用
				props传递、复用
		·jsx是什么
			·jsx语法
				·html形式
				·引入js变量和表达式
				·if...else...
				·循环
				·style和className
				·事件
				·jsx语法根本无法被浏览器所解析
			·jsx解析成js
				·jsx其实是语法糖
				·开发环境会将jsx编译成js代码
				·jsx的写法大大降低了学习成本和编码工作量
				·同时，jsx也增加dubug成本

				/* JSX 代码 */
				var profile = <div>
							  	<img src="1.png" className="profile">
							  	<h3>{[user.firstName, user.lastName].join(' ')}</h3>	
							  </div>
				// 解析结果
				var profile = React.createElement("div", null,
					React.createElement("img", { src: "1.png", className:"profile" }),
					React.createElement("h3", null, [user.firstName, user.lastName].join(" "))
				);

				/* JSX 代码 */
				render(){
					const list = this.props.data
					return(
						<ul>
							{
								list.map((item, index) => {
									return <li key={index}>{item}</li>
								})
							}
						</ul>	
					)
				}
				// 解析结果
				function render(){
					const list = this.props.data;
					return React.createElement(
						"ul",
						null,
						list.map((item, index) => {
							return React.createElement(
								"li",
								{ key: index },
								item
							)
						})
					)
				}
			·JSX独立的标准
				·JSX是react引入的，但不是react独有的
				·react已经将他作为了一个独立标准开放，其他项目也可用
				·React.createElement是可以自定义修改的
				·说明：本身功能已经完备；和其他标准兼容和扩展性没问题
		·jsx和vdom关系
			·分析：为何需要vdom
				·jsx需要渲染成html，数据驱动视图
				vdom是react初次推广开来的，结合jsx
				jsx就是模板，最终要渲染成html
				初次渲染+修改state后的re-render
				正好符合vdom的应用场景
			·React.createElement和h，都生成vnode
			·何时patch：ReactDOM.render(...)和setState
				初次渲染 - ReactDOM.render(<App/>, container)
				会触发patch(container，vnode)
				re-render - setState
				会触发patch(vnode, newVnode)
			·自定义组件的解析：初始化实例，然后执行render
				·自定义组件（class），vdom默认不认识
				·因此Input和List定义的时候必须声明render函数
				·根据props初始化实例，然后执行实例的render函数
				·render函数返回的还是vnode对象

				return(
					<div>
						<Input addTitle={this.addTitle.bind(this)} />
						<List data={this.state.list} />
					</div>
				)
				return React.createElement('div', null, 
					React.createElement(Input, {addTitle: this.addTitle.bind(this)}),
					React.createElement(List, {data: this.state.list})
				)

				/*
					React.createElement(List, {data: this.state.list})
					var list = new List({data: this.state.list})
					var vnode = list.render()
				*/
		·简述react的setState
			·setState的异步
				·为何需要异步
					·可能回一次执行多次setState
					·你无法规定、限制用户如何使用setState
					·没必要每次setstate都重新渲染，考虑性能
					·即便每次重新渲染，用户也看不到中间的效果
					·只看到最后的结果即可
			·vue修改属性也是异步
			·setState的过程
				·每个组件实例，都有renderComponent方法
				·执行renderComponent会重新执行实例的render
				·render函数返回newVnode，然后拿到preVnode
				·执行patch(preVnode,newVnode)
		·阐述如何比较react和vue
			·本质区别
				·vue - 本质MVVM框架，有MVC发展而来
				·React - 本质是前端组件化框架，由后端组件化发展而来
			·看模板和组件化的区别
				·vue - 使用模板（最初由angular提出）
				·React - 使用JSX
				·模板语法上，更倾向于react
				·模板分离上，更倾向于vue
					模板应该和js逻辑分离
					“开放封闭原则”
				·组件化区别
					·React本身就是组件化 - 更倾向于
					·vue也支持组件化，不过是在MVVM上的扩展
			·两者共同点
				业务场景大部分都没有问题
				·都支持组件化
				·都是数据驱动视图
				·国内使用，首推vue。文档易读易写、社区够大
				·团队水平较高，推荐React。组件化和JSX
	·hybrid
		·是什么，为何用
			·文字解释
				·hybrid即“混合”，即前端和客户端的混合开发
				·需前端开发和客户端开发配合完成
				·某些环节也可能涉及到server端
			·存在价值，为何会用
				·可以快速迭代更新【关键】（无需app审核）
				·体验流畅（和NA的体验基本类似）
				·减少开发和沟通成本，双端公用一套代码
			·webview
				·是app中的一个组件
				·用于加载h5页面，即一个小型的浏览器内核
			·file://协议
				·file协议：本地文件，快
				·http(s)协议：网络加载，慢
				·看file://和整个url的关系
			·hybrid实现流程
				·不是所有场景都适合使用hybrid
				·使用NA：体验要求极致，变化不频繁（如头条首页）
				·使用hybrid：体验要求高，变化频繁（如头条新闻详情页）
				·使用h5：体验无要求，不常用（如举报，反馈等页面）
				·具体实现：
					·前端做好静态页面，将文件交给客户端
					·客户端拿到前端静态页，以文件形式存储在app中
					·客户端在一个webview中
					·使用file协议加载静态页
				·遗留问题：
					·app发布之后，静态文件如何实时更新
					·静态页面如何获取内容？
		·如何更新上线
			·思考（目的，可行途径）
				·要替换每个客户端的静态文件
				·只能客户端来做
				·客户端去server下载最新的静态文件
				·自己维护server的静态文件
			·完整流程
				·分版本，有版本号
				·将静态文件压缩成zip包，上传到服务端
				·客户端每次启动，都去服务端检查版本号
				·如果服务端版本号大于客户端，就去下载最新zip包
				·客户端解压zip包，将现有文件覆盖
		·和h5有何区别
			·优点
				·体验更好，跟NA体验基本一致
				·可快速迭代，无需app审核
			·缺点
				开发成本高。联调、测试、查bug都比较麻烦
				运维成本高。
			·适用场景
				·hybrid：产品的稳定功能，体验要求高，迭代频繁（产品型）
				·h5：单次的运营活动或不常用功能（运营型）
		·js如何与客户端通信（js-sdk）
			·回顾遗留问题
				·新闻详情页适用hybrid，前端如何获取新闻内容？
					客户端获取新闻内容，然后js通讯拿到内容，再渲染
				·不能用ajax获取。第一跨域，第二速度慢
			·js和客户端通讯的基本形式
				js访问客户端能力，传递参数和回调函数
				客户端通过回调函数返回内容
			·schema协议简介和使用
				·前端和客户端通讯的约定
				·使用
					/* 演示 */
					var iframe = document.createElement('iframe');
					iframe.style.display = 'none';
					iframe.src = 'weixin://dl/scan';
					var body = document.body || document.getElementsByTagName('body')[0];
					body.appendChild(iframe);
					setTimeout(function(){
						body.removeChild(iframe);
						iframe = null
					})
					/* 如果要加上参数和callback，就要这么写 */
					window['_weixin_scan_callback'] = function(result){
						console.log(result)
					}
					// ...省略...
					iframe.src = 'weixin://dl/scan?k1=v1&k2=v2&k3=v3&callback=_weixin_scan_callback'
					// ...省略...

			·schema使用的封装
				/* 傻瓜式调用，不用再自己定义全局函数 */
				window.invoke.share({title: 'xxx', content: 'xxx'}, function(result){
					if(result.errno === 0){
						alert('分享成功')
					}else {
						//分享失败
						alert(result.message)
					}
				})

				//分享
				function invokeShare(data, callback){
					_invoke('share', data, callback)
				}
				//登录
				function invokeLogin(data, callback){
					_invoke('login', data, callback)
				}
				//打开扫一扫
				function invokeScan(data, callback){
					_invoke('scan', data, callback)
				}
				//暴露给全局
				window.invoke = {
					share: invokeShare,
					login: invokeLogin,
					scan: invokeScan
				}
				function _invoke(action, data, callback){
					// 拼接schema协议
					var schema = 'myapp://utils'
					schema += '/' + action

					schema += '?a=a'
					var key
					for(key in data){
						if(data.hasOwnProperty(key)){
							schema += '&' + key + '=' + data[key]
						}
					}
					// 处理callback
					var callbackName = ''
					if(typeof callback === 'string'){
						callbackName = callback
					}else{
						callbackName = cation + Date.now()
						window[callbackName] = callback
					}

					schema += '&callback=' + callbackName

					// iframe中调用schema
				}
			·内置上线
				·将以上封装的代码打包，叫做invoke.js，内置到客户端
				·客户端每次启动webview，都默认执行invoke.js
				·本地加载，免去网络加载的时间
				·本地加载，没有网络请求，看不到schema协议，更安全
			·问题解答
				·通讯的基本形式：调用能力，传递参数，监听回调
				·对schema协议的理解和使用
				·调用schema代码的封装
				·内置上线的好处:更快、更安全
	·其它
		·如何写博客
		·如何做开源