## 讲给大前端的后端课

- 前端与后端
- 前后端分离的那些套路
- 讲给前端程序员的后端套路

## 前端程序员为什么要懂点后端

- 对系统来讲前后端都不是孤立的
- 前后端的合作都很重要
- 想做全栈不明白后端就是一个笑话
- 与后端程序员互怼的时候占有优势

### 前端与后端

- 网络系统的演进史
- 前端与大前端
- 后端都有啥
- 前后端分离的意义。

> 用户可以看到的都属于前端，其它的属于后端范畴

### 大前端语言和技术

- es5 & es6 & es7 (es语言基础)
- html5 & css3
- less & sass（css预编译）
- svg & canvas & d3.js（图形学可视化）
- webgl & three.js（3d场景）
- cmd & amd & commonjs（语言标准）
- requirejs & seajs（es模块化库）
- CoffeeScript & TypeScript（es语言风格库）
- nodejs & express & koa（web服务器）

### 前后端代码组织形式演进

- 前后端未分离：前后端代码冗杂在一起
- 前后端半分离：前后端代码分离，部署未分离
- 前后端分离：前后端代码分离，部署分离

### 哪些情况需要前后端分离

- 页面布局复杂，使用了主题和样式。
- 需要有较高的页面渲染效果
- 前端页面中包含了复杂业务逻辑
- 页面需要渲染的数据量大

### 典型的应用场景

- H5游戏
- Native开发的移动App
- 浏览器插件
- 微信小程序
- Electron开发桌面应用
- 各类大型网站

### 总结：前后端分离的意义

- 前后端各司其职，工作各有分工
- 提高开发效率
- 完美对应前端需求的变化
- 增强代码的可维护性

### 前后端分离的那些套路

- 前后端分离流行技术方案
- 前后端通信手段
- 联合调试那些坑

## Node.js 架构分层方案

## 前后端交互形式

- 更多的是采用 Restful 风格的接口
- Rest是"呈现状态转移"（REpresentational State Transfer）的缩写，一种API的架构风格。在客户端和服务端之间通过呈现状态的转移来驱动应用的演进。

### RESTful 简介
- 使用GET、POST、PUT、DELETE这几种请求模式
- get(select) 从服务器抽取资源
- post(create) 在服务器创建一个资源
- put(update) 在服务器更新资源
- delete(delete) 从服务器删除资源

### 数据接口流程
