## 什么是PHP

> PHP（外文名：PHP：Hypertext Preprocessor，中文名：“超文本预处理器”）是一种通用开元脚本语言。语法吸收了C语言、Java和Perl的特点，利于学习，实用广泛，主要适用于Web开发领域。PHP独特的语法混合了C、Java、Perl以及PHP自创的语法。它可以比CGI或者Perl更快速的执行动态网页。用PHP做出的动态页面与 其他编程语言相比，PHP是将程序嵌入到HTML（标准通用标记语言下的一个应用）文档中去执行，执行效率比完全生成HTML标记的CGI要高许多；PHP还可以执行编译后代码，编译可以达到加密和优化代码运行，使代码运行更快。

也就是说PHP是一门后端语言（跑在机器上做一个服务）

那么我们前端为什么要学习PHP呢？

## 前端学习PHP的作用

1. 能够了解一些编程概念在这些实现了面向对象编程语言的实用
2. 在和后端开发工程师配合的时候有把握

## PHP语言的一些特点

1. PHP是一种脚本语言不需要编译。
2. PHP执行速度很快。
3. PHP可以嵌入在HTML里面
4. PHP每一句代码都要以分号结束

## PHP语法

### 变量声明

PHP变量要以相对应的$来分明

```php
$a = 3;
$b = 4;
$c = $a + $b;
echo $z; // 7 */
```

### 语言作用域

PHP变量作用域为块级作用域

```php
if(false){
    $aa = "测试";
}
echo $aa; // 报错 undefined variable */
```

### isset方法

isset方法可以判断PHP变量有没有被声明

```php
if(false) {
    $aa = "测试";
}
if(isset($aa)){
    echo $aa;
} else {
    echo "aa变量没有被声明";    //输出
}
```

### 函数取值及global、$GLOBALS[name]

在函数外部声明变量在函数内部拿不到，如果想要拿到必须在函数内部对需要的变量进行global一下。

```php
$aaa = "测试";
// php函数参数可以写入默认值
function test($b = ""){
    // echo $aaa; // 无法找到
    global $aaa;
    echo $aaa; // 测试
}
test();
// 通过引用过来的模块要想拿到模块中的变量可以通过$GLOBALS[]在引用模块中定义，在其他模块中获取
// 引用模块
$GLOBALS['aa'] = "aa";
// 其他模块
echo $GLOBALS['aa'] // 输出
```

### 引用外部文件

1. `require_once`：如果引用文件错误，会报错，且源文件无法执行。
2. `include_once`：如果引用文件报错，会报错，但不会影响源文件执行。

### PHP数组

```php
$arrayTest = array(0=> "苹果", 1=>"测试"); // 数组的定义方法
echo $arrayTest;
```

### json_encode方法

json_encode方法出入json格式的数据，例如上面数组

```php
$arrayTest = array(0=> "苹果", 1=>"测试"); // 数组的定义方法
echo json_encode($arrayTest); // json_encode输出json格式
```

### 会话机制session

session同样通过$_SESSION定义

```php
// 定义session
$_SESSION['data'] = 1;
// 取session
echo $_SESSION['data'];
```

### 处理请求

_设置响应报头_

```php
header("Content-type: text/json;charset = utf-8");
```

_通过`$_GET[]`方法获取GET请求参数_

```php
$username = $_GET['username'];
$password = $_GET['password'];
```

_通过`$_POST[]`方法获取POST请求参数_

```php
$username = $_POST['username'];
$password = $_POST['password'];
```

_通过`$_REQUEST[]`方法可以获取GET和POST的请求参数_

```php
$username = $_REQUEST['username'];
$password = $_REQUEST['password'];
```

_简单处理请求_

```php
if($username == "admin" && $password == "123456"){
    echo json_encode(array('msg'=> "登录成功",'errorCode'=> 'OK'));
} else {
    echo json_encode(array('msg'=> "登录失败",'errorCode'=> 'OK'));
}
```
