###设计的功能
·资源的合并与压缩
	·理解减少http请求数量和减少请求资源大小两个优化要点
	·掌握压缩与合并的原理
		·减少http请求数量
		·减少请求资源的大小
			·html压缩
			·css压缩
			·js的压缩和混乱
			·文件合并
				·首屏渲染问题
				·缓存失效问题
				解决：
					·公共库合并
					·不同页面的合并
			·开启gzip
	·掌握通过在线网站和fis3两种实现压缩与合并的方法
	·浏览器的一个请求从发送到返回都经历了什么？
		·请求过程中一些潜在的性能优化点
			·dns是否可以通过缓存减少dns查询时间？
			·网络请求的过程走最近的网络环境？
			·相同的静态资源是否可以缓存？
			·能否减少请求http请求大小？
			·减少http请求
			·服务端渲染
·图片编解码原理和类型选择
	·jpg有损压缩，压缩率高，不支持透明-大部分不需要透明图片的业务场景
	·png支持透明，浏览器兼容好-大部分需要透明图片的业务场景
	·webp压缩程度更好，在ios webview有兼容性问题-安卓全部
	·svg矢量图，代码内嵌，相对较小，图片样式相对简单的场景-图片样式相对简单的业务场景
	·CSS雪碧图-www.spritecow.com
	·Image inline-base64  智图zhitu.isux.us压缩
	·使用矢量图
		使用SVG进行矢量图的绘制
		使用iconfont解决icon问题
·浏览器渲染机制
	·HTML渲染过程的一些特点
		·顺序执行、并发加载
			词法分析
			并发加载
			并发上限
		·是否阻塞
			·css阻塞
				css head中阻塞页面的渲染
				css阻塞js的执行
				css不阻塞外部脚本的加载
			·js阻塞
				直接引入的js阻塞页面的渲染
				js不阻塞资源的加载
				js顺序执行，阻塞后续js逻辑的执行

		·依赖关系
			页面渲染依赖于css的加载
			js的执行顺序的依赖关系
			js逻辑对于dom节点的依赖关系
		·引入方式
			·js引入方式
				直接引入
				defer
				async
				异步动态引入js
·懒加载预加载
	·理解浏览器重绘与回流的机制
		·css性能让javascript变慢？
			·回流
				当render tree中的一部分(或全部)因为元素的规模尺寸，布局，隐藏等改变而需要重新构建。这就称为回流(reflow)
				当页面布局和几何属性改变时就需要回流
			·重绘
				当render tree中的一些元素需要更新属性，而这些属性只是影响元素的外观，风格，而不会影响布局的，比如background-color。则就叫称为重绘。
·浏览器存储
	·理解localstorage、cookie、sessionstorage、indexdb的概念和使用
		·Cookie
			·因为HTTP请求无状态，所以需要cookie去维持客户端状态
			·过期时间 expire
			·cookie的生成方式
			     1. http response header中的set-cookie
			     2. js中可以通过document.cookie可以读写cookie
			·仅仅作为浏览器存储（大小4KB左右，能力被localstorage替代）
			·cookie中在相关域名下面 —— cdn的流量损耗		解决：cdn的域名和主站的域名要分开
			·httponly（不支持js读写）
		·LocalStorage
			·HTML5设计出来专门用于浏览器存储的
			·大小为5M左右
			·仅在客户端使用，不和服务端进行通信
			·接口封装较好
			·浏览器本地缓存方案
		·SessionStorage
			·会话级别的浏览器存储
			·大小为5M左右
			·仅在客户端使用，不和服务端进行通信
			·接口封装较好
			·对于表单信息的维护
		·IndexedDB
			·IndexedDB 是一种低级API，用于客户端存储大量结构化数据。该API使用索引来实现对该数据的高性能搜索。虽然 Web Storage 对于存储较少量的数据很有用，但对于存储更大量的结构化数据来说，这种方法不太有用。IndexedDB提供了一个解决方案。
			·为应用创建离线版本
	·学习理解pwa和service worker的应用
		·pwa
			·PWA (Progressive Web Apps) 是一种 Web App 新模型，并不是具体指某一种前沿的技术或者某一个单一的知识点，我们从英文缩写来看就能看出来，这是一个渐进式的 Web App，是通过一系列新的 Web 特性，配合优秀的 UI 交互设计，逐步的增强 Web App 的用户体验。
			·可靠：在没有网络的环境中也能提供基本的页面访问，而不会出现“未连接到互联网”的页面。
			·快速：针对网页渲染及网络数据访问有较好优化。
			·融入（Engaging）：应用可以被增加到手机桌面，并且和普通应用一样有全屏、推送等特性。
		·检测 lighthouse （下载地址：https://lavas.baidu.com/doc-assets/lavas/vue/more/downloads/lighthouse_2.1.0_0.zip）
		·Service Worker
			是一个脚本，浏览器独立于当前网页，将其在后台运行,为实现一些不依赖页面或者用户交互的特性打开了一扇大门。在未来这些特性将包括推送消息,背景后台同步， geofencing（地理围栏定位），但它将推出的第一个首要特性，就是拦截和处理网络请求的能力，包括以编程方式来管理被缓存的响应。
				·使用拦截和处理网络请求的能力，去实现一个离线应用
				·在后台运行同时能和页面通信的能力，去实现大规模后台数据的处理
			·chrome://serviceworker-internals/
			·chrome://inspect/#service-workers

·缓存机制（httpheader）
	·理解cache-control所控制的缓存策略
		·cache-control
			·max-age 	缓存最大有效时间（http1.1，优先级比过期时间expires更高,expires是http1.0的）
			·s-maxage	类似max-age，优先级更高，但是只对于public缓存设备（如cdn）才会生效
			·private	私人访问，个人计算机。
			·public 	所有用户都可访问的，如cdn。
			·no-cache 	max-age=0，no-cache。意思就是会发请求到服务端，比如last-modified信息进一步判断当前浏览器缓存有没有过期。就是所有请求都到服务端
			·no-store	完全不使用缓存
			·expires 	缓存过期时间，指定资源到期的时间。当有max-age字段就会被忽略，两个都是强浏览器缓存策略，有字段的时候，都会从浏览器直接读取资源，而不会向服务端发请求。
			·Last-Modified/If-Modified-Since
				·基于客户端和服务端协商的缓存机制
				·last-modified——response header
				·if-modified-since——request header
				·需要与cache-control共同使用
				·缺点
					·某些服务端不能获取精确的修改时间
					·文件修改时间改了，但文件内容却没有变
					解决：etag
	·理解last-modified和etag以及整个服务端浏览器端的缓存流程
		·Etag/If-None-Match
			·文件内容的hash值（根据文件内容改变）
			·etag——response header
			·if-none-match——request header
			·需要与cache-control共同使用
		·分级缓存策略
			顶层-200状态
				当浏览器本地没有缓存或者下一层失效时，或者用户点击了强刷新，浏览器直接去服务器下载最新数据
			中层-304状态
				由last-modified/etag控制。当下一层失效时或用户点击refresh时，浏览器就会发送请求给服务器，如果服务器端没有变化，则返回304给浏览器
			底层-200状态（from cache）
				这一层由expires/cache-control控制，只要没有失效，浏览器只访问自己的缓存
·PWA
·Vue-SSR
	·vue渲染问题
	·多层次的优化方案
		·构建层模板编译
		·数据无关的prerender的方式
		·服务端渲染


