# 高效前端阅读笔记整理

> 整理中...

- [x] 第1章 HTML/CSS优化
  - [ ] Effective 1: 能用HTML/CSS解决的问题就不要用JS
  - [ ] Effective 2: 优化HTML标签
  - [ ] Effective 3: 用CSS画一个三角形
  - [ ] Effective 4: 尽可能地使用伪元素
- [x] 第2章 JS优化
  - [ ] Effective 5: 减少前端代码耦合
  - [ ] Effective 6: JS书写优化
- [x] 第3章 页面优化
  - [ ] Effective 7: 避免页面卡顿
  - [ ] Effective 8: 加快页面打开速度
  - [ ] Effective 9: 增强用户体验
  - [ ] Effective 10: 用好Chrome Devtools
- [x] 第4章 HTML5优化实践
  - [ ] Effective 11: 使用H5的history改善AJAX列表请求体验
  - [ ] Effective 12: 使用图标替代雪碧图
  - [ ] Effective 13: 理解和使用CSS3动画
  - [x] [Effective 14: 实现前端裁剪压缩图片](https://github.com/lsxlsxxslxsl/Read-Books-Notes/blob/master/post/%E9%AB%98%E6%95%88%E5%89%8D%E7%AB%AF%EF%BC%9AWeb%E9%AB%98%E6%95%88%E7%BC%96%E7%A8%8B%E4%B8%8E%E4%BC%98%E5%8C%96%E5%AE%9E%E8%B7%B5/Effective%2014/%E5%AE%9E%E7%8E%B0%E5%89%8D%E7%AB%AF%E8%A3%81%E5%89%AA%E5%8E%8B%E7%BC%A9%E5%9B%BE%E7%89%87.md)
  - [x] [Effective 15: 实现跨浏览器的HTML5表单验证](https://github.com/lsxlsxxslxsl/Read-Books-Notes/blob/master/post/%E9%AB%98%E6%95%88%E5%89%8D%E7%AB%AF%EF%BC%9AWeb%E9%AB%98%E6%95%88%E7%BC%96%E7%A8%8B%E4%B8%8E%E4%BC%98%E5%8C%96%E5%AE%9E%E8%B7%B5/Effective%2015/%E5%AE%9E%E7%8E%B0%E8%B7%A8%E6%B5%8F%E8%A7%88%E5%99%A8%E7%9A%84HTML5%E8%A1%A8%E5%8D%95%E9%AA%8C%E8%AF%81.md)
  - [ ] Effective 16: 使用Service Worker 做一个PWA离线网页应用
- [x] 第5章 前端与计算机基础
  - [ ] Effective 17: 理解 WebSocket 和 TCP/IP
  - [ ] Effective 18: 理解HTTP5连接的前几毫秒发生了什么
  - [ ] Effective 19: 弄懂为什么 0.1+0.2 不等 0.3
  - [ ] Effective 20: 明白 WebAssembly 与程序编译
  - [ ] Effective 21: 理解JS与多线程
  - [ ] Effective 22: 学会 JS 与面向对象
  - [ ] Effective 23: 了解SQL
  - [ ] Effective 24: 学习常用的前端算法与数据结构
- [x] 第6章 掌握前端基础
  - [ ] Effective 25: 掌握同源策略和跨域
  - [x] [Effective 26: 掌握前端本地文件操作与上传](https://github.com/lsxlsxxslxsl/Read-Books-Notes/blob/master/post/%E9%AB%98%E6%95%88%E5%89%8D%E7%AB%AF%EF%BC%9AWeb%E9%AB%98%E6%95%88%E7%BC%96%E7%A8%8B%E4%B8%8E%E4%BC%98%E5%8C%96%E5%AE%9E%E8%B7%B5/Effective%2026/%E6%8E%8C%E6%8F%A1%E5%89%8D%E7%AB%AF%E6%9C%AC%E5%9C%B0%E6%96%87%E4%BB%B6%E6%93%8D%E4%BD%9C%E4%B8%8E%E4%B8%8A%E4%BC%A0.md)
  - [ ] Effective 27: 学会常用的 CSS 居中方式
  - [ ] Effective 28: 学会常用的 CSS 布局技术
  - [ ] Effective 29: 理解字号与行高
  - [ ] Effective 30: 使用响应式开发
  - [x] [Effective 31: 明白移动端 click 及自定义事件](https://github.com/lsxlsxxslxsl/Read-Books-Notes/blob/master/post/%E9%AB%98%E6%95%88%E5%89%8D%E7%AB%AF%EF%BC%9AWeb%E9%AB%98%E6%95%88%E7%BC%96%E7%A8%8B%E4%B8%8E%E4%BC%98%E5%8C%96%E5%AE%9E%E8%B7%B5/Effective%2031/%E7%90%86%E8%A7%A3%E7%A7%BB%E5%8A%A8%E7%AB%AFclick%E5%8F%8A%E8%87%AA%E5%AE%9A%E4%B9%89%E4%BA%8B%E4%BB%B6.md)
  - [x] [Effective 32: 学习 JS 高级技巧](https://github.com/lsxlsxxslxsl/Read-Books-Notes/blob/master/post/%E9%AB%98%E6%95%88%E5%89%8D%E7%AB%AF%EF%BC%9AWeb%E9%AB%98%E6%95%88%E7%BC%96%E7%A8%8B%E4%B8%8E%E4%BC%98%E5%8C%96%E5%AE%9E%E8%B7%B5/Effective%2032/%E5%AD%A6%E4%B9%A0JS%E9%AB%98%E7%BA%A7%E6%8A%80%E5%B7%A7.md)
- [x] 第7章 运用恰当的工具
  - [x] [Effective 33: 前端的单元测试与自动化测试](https://github.com/lsxlsxxslxsl/Read-Books-Notes/blob/master/post/%E9%AB%98%E6%95%88%E5%89%8D%E7%AB%AF%EF%BC%9AWeb%E9%AB%98%E6%95%88%E7%BC%96%E7%A8%8B%E4%B8%8E%E4%BC%98%E5%8C%96%E5%AE%9E%E8%B7%B5/Effective%2033/%E5%89%8D%E7%AB%AF%E7%9A%84%E5%8D%95%E5%85%83%E6%B5%8B%E8%AF%95%E4%B8%8E%E8%87%AA%E5%8A%A8%E5%8C%96%E6%B5%8B%E8%AF%95.md)
  - [x] Effective 34: 使用 AE + bodymovin 制作网页动画

本书已读完，笔记会陆续整理出来，有些没整理是个人觉得没必要，会把精华部分列出来。

### 评价：

总体来说本书适合有一些工作经验的人看，涉及到很多底层的优化技巧，还是推荐大家去看看。
